// v1.4
// unidade que trata das portas
unit Portas ;


interface

type
   Porta = class
   private
      _estado : Boolean ;  // indica se porta est aberta ou fechada
   public
      constructor Create                     ;
      destructor  Destroy         ; override ;
      function    obterEstado     : Boolean  ;
      procedure   mudarEstadoPorta           ;
   end ; // Porta


implementation

// Todas as portas so criadas fechadas
constructor Porta.Create ;
begin
   _estado := false ;  // estado falso indica porta fechada
   inherited Create( ) ;
end ; // Porta.Create


// funo destrutora para a classe porta
destructor Porta.Destroy ;
begin
   // no faz nada!
    inherited Destroy( ) ;
end ; // Porta.Destroy


// devolve estado da porta: aberto ou fechado
function Porta.obterEstado : Boolean ;
begin
   result := _estado ;
end ; // Porta.obterEstado


// abre uma porta fechada e fecha uma porta aberta
procedure Porta.mudarEstadoPorta ;
begin
   _estado := NOT _estado ; // basta inverter o estado
end ; // Porta.mudarEstadoPorta

end .

// Portas.pas -> v1.4
